# ======================================================
# NEEDED
# ===========================
# If you want TeamLead to work well, you do need
# cagemonkeys endmap addon:
#   http://addons.eventscripts.com/addons/view/13321
# Be sure you +woot it, it's really great!
# ======================================================


# ======================================================
# IMPORTS
# ===========================
# PYTHON IMPORTS
import os
# ES IMPORTS
import es
import gamethread
import playerlib
import usermsg
import settinglib
import popuplib
# ======================================================


# ======================================================
# ADDON INFO
# ===========================
info = es.AddonInfo()
info.name     = 'TeamLead'
info.version  = '2.0.1'
info.basename = 'teamlead'
info.author   = 'Ratzee and PitBull (pitbull0993)'

es.ServerVar('teamlead', info.version).makepublic()
#======================================================


# ======================================================
# DICTS AND VARS
# ===========================
streaks = {'t':0,'ct':0}
advert = 0
dir_es = str(es.server_var['eventscripts_addondir']).replace('\\', '/')
dir_sound = dir_es.replace('addons/eventscripts', 'sound/quake/teamlead/')
sounds = {}
for folder in os.listdir(dir_sound):
    if not os.path.isdir(dir_sound+folder):
        continue
    sounds[folder] = []
    for file in os.listdir(dir_sound+folder):
        if not os.path.isfile(dir_sound+folder+"/"+file):
            continue
        if not file.endswith('.wav'):
            continue
        file = file.replace('.wav', '')
        sounds[folder].append(file)
# ======================================================


# ======================================================
# FUNCTIONS
# ===========================
def announce(text, color=None, filter='#all', score=0):
    for userid in playerlib.getUseridList(filter):
        if score == 1 and scoresound.get(userid) == "off":
            return
        
        announce_mode = announcestyle.get(userid)
        if announce_mode == 'off':
            return
        if announce_mode == 'cmsg':
            gamethread.delayed(2, usermsg.centermsg, (userid, text))
        elif announce_mode == 'hh':
            gamethread.delayed(2, usermsg.hudhint, (userid, text))
        elif announce_mode == 'chat':
            text = '\3' + text
            if color == 'blue':
                index = es.createplayerlist(playerlib.getUseridList('#ct')[0])[int(playerlib.getUseridList('#ct')[0])]['index']
            elif color == 'red':
                index = es.createplayerlist(playerlib.getUseridList('#t')[0])[int(playerlib.getUseridList('#t')[0])]['index']
            else:
                index = -1
            gamethread.delayed(2, usermsg.saytext2, (userid, index, text))

def play(sound, filter='#all', score=0):
    for userid in playerlib.getUseridList(filter):
        if score == 1 and scoresound.get(userid) == "off":
            return
        
        sound_style = soundstyle.get(userid)
        if sound_style == 'off':
            return
        if not sounds.has_key(sound_style):
            return
        if not sound in sounds[sound_style]:
            sound_style = 'default'
        gamethread.delayed(2, es.cexec, (userid, "play quake/teamlead/%s/%s.wav" % (sound_style, sound)))

def infopopup():
    infomenu.send(es.getcmduserid())

def getScores():
    es.set('t_score', 0)
    es.set('ct_score', 0)
    es.server.cmd('score get t_score #t')
    es.server.cmd('score get ct_score #ct')
    return es.getInt('t_score'), es.getInt('ct_score')

def infoselect(userid, choice, popupname):
    if choice == 1:
        soundstyle.send(userid)
    elif choice == 2:
        announcestyle.send(userid)
    elif choice == 3:
        scoresound.send(userid)

def downloadables():
    for key in sounds:
        for subkey in sounds[key]:
            es.server.cmd("es downloadable sound/quake/teamlead/%s/%s.wav" % (str(key), str(subkey)))

# ======================================================


# ======================================================
# EVENTS
# ===========================
def load():
    if not es.exists('saycommand', '!teamlead'):
        es.regsaycmd('!teamlead', 'teamlead/infopopup', 'Send Info Popup')
    downloadables()

def unload():
    es.unregsaycmd('!teamlead')

def player_activate(event_var):
    gamethread.delayed(15, es.tell, (event_var['userid'], '#multi', "#green[TeamLead] #defaultSay '!teamlead' for settings."))

def es_map_start(event_var):
    streaks = {'t':0,'ct':0}
    downloadables()

def round_start(event_var):
    advert += 1
    if advert == 5:
        es.msg('#multi', "#green[TeamLead]#default Say '!teamlead' for settings.")
        advert = 0
    
    t_score, ct_score = getScores()
    
    if t_score == 0 and ct_score == 0:
        streaks['t'] = 0
        streaks['ct'] = 0

def round_end(event_var):
    t_score, ct_score = getScores()
    winner = int(event_var['winner'])
    
    # If terrorists win, increase their streak by one/1 and set the CT one to zero/0
    if winner == 2:
        streaks['t'] += 1
        streaks['ct'] = 0
        
        # If the terrorists streak is 4, "Red Team is Dominating!"
        if streaks['t'] == 4:
            announce("Red Team is Dominating!", "red")
            play("red_dominating")
            return
        
        # If the terrorists streak is 8, "Red Team is increasing their lead!"
        if streaks['t'] == 8:
            announce("Red Team increases their lead!", "red")
            play("red_increases")
            return
        
        # If the score of the terrorists is one more than the one of the CTs, "Red Team Leads!"
        if t_score - ct_score == 1:
            announce("Red Team Leads!", "red")
            play("red_leads")
            return
        
        # If both scores are the same, "Teams are tied!"
        if t_score == ct_score:
            announce("Teams are tied!")
            play("teams_tied")
            return
        
        # If activated, "Red Team Scores!"
        announce("Red Team Scores!", "red", score=1)
        play("red_scores", score=1)
    
    # If counter-terrorists win, increase their streak by one/1 and set the T one to zero/0
    elif winner == 3:
        streaks['ct'] += 1
        streaks['t'] = 0
        
        # If the counter-terrorists streak is 4, "Blue Team is Dominating!"
        if streaks['ct'] == 4:
            announce("Blue Team is Dominating!", "blue")
            play("blue_dominating")
            return
            
        # If the counter-terrorists streak is 8, "Blue Team is increasing their lead!"
        if streaks['ct'] == 8:
            announce("Blue Team increases their lead!", "blue")
            play("blue_increases")
            return
        
        # If the score of the counter-terrorists is one more than the one of the Ts, "Blue Team Leads!"
        if ct_score - t_score == 1:
            announce("Blue Team Leads!", "blue")
            play("blue_leads")
            return
        
        # If both scores are the same, "Teams are tied!"
        if t_score == ct_score:
            announce("Teams are tied!")
            play("teams_tied")
            return
        
        # If activated, "Blue Team Scores!"
        announce("Blue Team Scores!", "blue", score=1)
        play("blue_scores", score=1)

def map_end(event_var):
    # Get Scores
    t_score, ct_score = getScores()
    
    # If the score of the terrorists is 0, "Blue Team did a flawless victory!"
    if t_score == 0:
        announce("Flawless Victory!", "blue", "#ct")
        announce("Humiliating Defeat!", "red", "#t")
        play("flawless_victory", '#ct')
        play("humiliating_defeat", '#t')
        return
    
    # If the score of the counter-terrorists is 0, "Red Team did a flawless victory!"
    if ct_score == 0:
        announce("Flawless Victory!", "red", "#t")
        announce("Humiliating Defeat!", "blue", "#ct")
        play("flawless_victory", '#t')
        play("humiliating_defeat", '#ct')
        return
    
    # If the score of the terrorists is higher than the one of the CTs, "Red Team is the Winner!"
    if t_score > ct_score:
        announce("Red Team is the Winner!", "red")
        play("red_winner")
    
    # If the score of the counter-terrorists is higher than the one of the Ts, "Blue Team is the Winner!"
    elif ct_score > t_score:
        announce("Blue Team is the Winner!", "blue")
        play("blue_winner")
    
    # If both scores are the same, "Teams did a tied win!"
    elif t_score == ct_score:
        announce("Teams did a tied win!")
        play("teams_tied")

# ======================================================


# ======================================================
# POPUPS
# ===========================
soundstyle = settinglib.create('soundstyle', 'Soundstyle', 'list')
soundstyle.addoption("default", "Default")
soundstyle.addoption("child", "Child")
soundstyle.addoption("female1", "Female 1")
soundstyle.addoption("female2", "Female 2")
soundstyle.addoption("off", "Deactivate")
soundstyle.setdefault("default")
soundstyle.addsound("ui/buttonclick.wav")

scoresound = settinglib.create('scoresound', 'Scoresound', 'list')
scoresound.addoption("yes", "Yes")
scoresound.addoption("no", "No")
scoresound.setdefault("no")
scoresound.addsound("ui/buttonclick.wav")

announcestyle = settinglib.create('announcestyle', 'Announcestyle', 'list')
announcestyle.addoption("cmsg", "Centermessage")
announcestyle.addoption("hh", "Hudhint")
announcestyle.addoption("chat", "Chat")
announcestyle.addoption("off", "Deactivate")
announcestyle.setdefault("cmsg")
announcestyle.addsound("ui/buttonclick.wav")

infomenu = popuplib.create('teamlead_info_menu')
infomenu.addline("TeamLead")
infomenu.addline("---------------")
infomenu.addline("	by Ratzee and PitBull")
infomenu.addline("---------------")
infomenu.addline("->1. Soundstyle Options")
infomenu.addline("->2. Announcestyle Options")
infomenu.addline("->3. Score Sound Options")
infomenu.addline(" ")
infomenu.addline(" ")
infomenu.addline(" ")
infomenu.addline(" ")
infomenu.select(1, infoselect)
infomenu.select(2, infoselect)
infomenu.select(3, infoselect)
# ======================================================